package cn.ibizlab.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.sample.domain.IBIZQJ;
import cn.ibizlab.core.sample.filter.IBIZQJSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBIZQJ] 服务对象接口
 */
public interface IIBIZQJService extends IService<IBIZQJ> {

    boolean create(IBIZQJ et);
    void createBatch(List<IBIZQJ> list);
    boolean update(IBIZQJ et);
    void updateBatch(List<IBIZQJ> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    IBIZQJ get(String key);
    IBIZQJ getDraft(IBIZQJ et);
    boolean checkKey(IBIZQJ et);
    boolean save(IBIZQJ et);
    void saveBatch(List<IBIZQJ> list);
    Page<IBIZQJ> searchDefault(IBIZQJSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBIZQJ> getIbizqjByIds(List<String> ids);
    List<IBIZQJ> getIbizqjByEntities(List<IBIZQJ> entities);
}


